Index: trunk/src/world_entities/WorldEntities.am
===================================================================
--- trunk/src/world_entities/WorldEntities.am	(revision 9110)
+++ trunk/src/world_entities/WorldEntities.am	(revision 9235)
@@ -4,7 +4,10 @@
                 world_entities/npcs/npc_test.cc \
                 world_entities/npcs/ground_turret.cc \
+                world_entities/npcs/space_turret.cc \
                 world_entities/npcs/generic_npc.cc \
                 world_entities/npcs/door.cc \
+                world_entities/npcs/gate.cc \
                 world_entities/npcs/repair_station.cc \
+                world_entities/npcs/attractor_mine.cc \
                 \
                 world_entities/environment.cc \
@@ -22,4 +25,5 @@
                 \
                 world_entities/weapons/test_gun.cc \
+                world_entities/weapons/laser_cannon.cc \
                 world_entities/weapons/turret.cc \
                 world_entities/weapons/aiming_turret.cc \
@@ -28,11 +32,15 @@
                 world_entities/weapons/hyperblaster.cc \
                 world_entities/weapons/aim.cc \
+                world_entities/weapons/aiming_system.cc \
                 world_entities/weapons/fps_sniper_rifle.cc \
+                world_entities/weapons/boomerang_gun.cc \
                 \
                 world_entities/projectiles/bomb.cc \
                 world_entities/projectiles/laser.cc \
+                world_entities/projectiles/rail_projectile.cc \
                 world_entities/projectiles/test_bullet.cc \
                 world_entities/projectiles/rocket.cc \
                 world_entities/projectiles/guided_missile.cc \
+                world_entities/projectiles/boomerang_projectile.cc \
                 world_entities/projectiles/hyperblast.cc \
                 \
@@ -70,6 +78,8 @@
                 npcs/npc_test1.h \
                 npcs/ground_turret.h \
+                npcs/space_turret.h \
                 npcs/door.cc \
-                npcs/repair_station.cc \
+                npcs/repair_station.h \
+                npcs/attractor_mine.h \
                 \
                 environment.h \
@@ -87,4 +97,5 @@
                 \
                 weapons/test_gun.h \
+                weapons/laser_cannon.cc \
                 weapons/cannon.h \
                 weapons/hyperblaster.h \
@@ -92,12 +103,16 @@
                 weapons/aiming_turret.h \
                 weapons/targeting_turret.h \
+                weapons/boomerang_gun.h \
                 weapons/aim.h \
+                weapons/aiming_system.h \
                 weapons/fps_sniper_rifle.h \
                 \
                 projectiles/bomb.h \
                 projectiles/laser.h \
+                projectiles/rail_projectile.h \
                 projectiles/test_bullet.h \
                 projectiles/rocket.h \
                 projectiles/guided_missile.h \
+                projectiles/boomerang_projectile.h \
                 projectiles/hyperblast.h \
                 \
Index: trunk/src/world_entities/camera.cc
===================================================================
--- trunk/src/world_entities/camera.cc	(revision 9110)
+++ trunk/src/world_entities/camera.cc	(revision 9235)
@@ -36,5 +36,5 @@
   this->setFovy(90);
   this->setAspectRatio(1.2f);
-  this->setClipRegion(.1, 2000);
+  this->setClipRegion(.1, 10000);
 
   this->setViewMode(Camera::ViewNormal);
Index: trunk/src/world_entities/creatures/fps_player.cc
===================================================================
--- trunk/src/world_entities/creatures/fps_player.cc	(revision 9110)
+++ trunk/src/world_entities/creatures/fps_player.cc	(revision 9235)
@@ -29,6 +29,8 @@
 #include "weapons/cannon.h"
 #include "weapons/fps_sniper_rifle.h"
+#include "weapons/aiming_system.h"
 
 #include "aabb.h"
+
 
 #include "key_mapper.h"
@@ -57,4 +59,7 @@
 {
   this->setPlayer(NULL);
+
+  if( this->aimingSystem)
+    delete this->aimingSystem;
 }
 
@@ -81,5 +86,4 @@
 {
   this->setClassID(CL_FPS_PLAYER, "FPSPlayer");
-
 
   this->bLeft = false;
@@ -89,4 +93,5 @@
   this->bJump = false;
   this->bPosBut = false;
+  this->bFire = false;
 
   this->xMouse = 0.0f;
@@ -125,9 +130,10 @@
 
 //   this->addWeapon(wpLeft, 1, 0);
-  this->addWeapon(wpRight,1, 0);
+  if( State::isOnline())
+    this->addWeapon(wpRight,1, 0);
   this->getWeaponManager().changeWeaponConfig(1);
 
   this->getWeaponManager().setSlotCount(2);
-//   this->getWeaponManager().setSlotDirection(0, Quaternion(M_PI_2, Vector(0,1,0)));
+  this->getWeaponManager().setSlotDirection(0, Quaternion(M_PI_4*-0.55f, Vector(0,0,1)));
   this->getWeaponManager().setSlotCapability(0, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
   this->getWeaponManager().setSlotDirection(1, Quaternion(M_PI_4*.5, Vector(1,0,0)));
@@ -135,4 +141,6 @@
   this->getWeaponManager().setSlotPosition(1, Vector(5.0, 0.0, 0.0));
 
+//   this->getWeaponManager().getFixedTarget()->setRelDir(Quaternion(M_PI_4*-0.6f, Vector(0,0,1)));
+
 
   this->getWeaponManager().setParentNode(&this->cameraNode);
@@ -141,4 +149,9 @@
   this->getWeaponManager().getFixedTarget()->setParent(&this->cameraNode);
   this->getWeaponManager().getFixedTarget()->setRelCoor(1000,0,0);
+
+  this->aimingSystem = new AimingSystem(this);
+  //this->addChild(this->aimingSystem);
+  wpRight->addChild(this->aimingSystem);
+//   this->getWeaponManager().sl
 
 
@@ -148,6 +161,16 @@
   registerVar( new SynchronizeableBool( &bForward, &bForward, "bForward", PERMISSION_OWNER ) );
   registerVar( new SynchronizeableBool( &bBackward, &bBackward, "bBackward", PERMISSION_OWNER ) );
+  registerVar( new SynchronizeableBool( &bJump, &bJump, "bJump", PERMISSION_OWNER ) );
   registerVar( new SynchronizeableFloat( &heading, &heading, "heading", PERMISSION_OWNER ) );
   registerVar( new SynchronizeableFloat( &attitude, &attitude, "attitude", PERMISSION_OWNER ) );
+
+    //subscribe to collision reaction
+  this->subscribeReaction(CREngine::CR_PHYSICS_FULL_WALK, CL_BSP_ENTITY);
+
+  this->initWeapon = false;
+  this->damageTicker = 0.0f;
+
+  if( State::isOnline())
+    toList( OM_PLAYERS );
 }
 
@@ -192,13 +215,7 @@
   this->getWeaponManager().getFixedTarget()->setRelCoor(0,0,0);
 
-
-  AABB* box = this->getModelAABB();
-  if( box != NULL)
-  {
-    State::getCameraNode()->setRelCoor(0, box->halfLength[1] * 2.0f, 0);
-    State::getCameraTargetNode()->setRelCoor(10, box->halfLength[1] * 2.0f, 0);
-
-    this->getWeaponManager().setSlotPosition(0, Vector(1.5, box->halfLength[1] * 2.0f - 0.7, 1.1));
-    this->getWeaponManager().setSlotPosition(1, Vector(5.0, box->halfLength[1] * 2.0f, 0.0));
+  if ( !State::isOnline() )
+  {
+    this->respawn();
   }
 }
@@ -219,11 +236,77 @@
 {
 
-  if( this->bPosBut)
-  {
-    this->bPosBut = false;
-    printf("mechanic2:walkTo( %f, mtheight, %f)\n",this->getAbsCoorX(),this->getAbsCoorZ());
-  }
-
-  Playable::tick( time );
+  if ( !this->initWeapon )
+  {
+    this->initWeapon = true;
+
+    this->cameraNode.setParentMode(PNODE_ROTATE_AND_MOVE);
+
+    this->getWeaponManager().getParentNode()->setParentMode(PNODE_ROTATE_AND_MOVE);
+    this->getWeaponManager().getFixedTarget()->setParent(&this->cameraNode);
+    this->getWeaponManager().getFixedTarget()->setParentMode(PNODE_ROTATE_AND_MOVE);
+
+
+    this->aimingSystem->toList(OM_GROUP_01);
+    this->aimingSystem->setParent(&this->cameraNode);
+//     this->aimingSystem->setParentMode(PNODE_ROTATE_AND_MOVE);
+    this->aimingSystem->setRelDir(Quaternion(M_PI_4*-0.58f, Vector(0,0,1)));
+    this->aimingSystem->setRelCoor(0, -1, -1);
+
+
+    AABB* box = this->getModelAABB();
+    if( box != NULL)
+    {
+      float f = 1.0;
+      this->cameraNode.setRelCoor(0, box->halfLength[1] * f, 0);
+//       this->cameraNode.setRelCoor(10, box->halfLength[1] * f, 0);
+
+      float v = 0.1f;
+      this->getWeaponManager().setSlotPosition(0, Vector(-8.0, box->halfLength[1] * v, 1.1));
+      this->getWeaponManager().setSlotPosition(1, Vector(5.0, box->halfLength[1] * v, 0.0));
+    }
+  }
+
+
+  this->getWeaponManager().tick(time);
+  if( this->bFire)
+  {
+    this->getWeaponManager().fire();
+
+//     WorldEntity* target = this->aimingSystem->getNearestTarget();
+//     if( target != NULL)
+//     {
+//       PRINTF(0)("hit hit hit, got: %s\n", target->getClassName());
+//     }
+//     else
+//     {
+//       PRINTF(0)("nothing hit\n");
+//     }
+  }
+
+
+  //dealing damage
+
+  if ( State::isOnline() && SharedNetworkData::getInstance()->isGameServer() )
+  {
+    this->damageTicker -= time;
+
+    if ( this->damageTicker <= 0.0f && this->beFire() )
+    {
+      this->damageTicker = 0.25;
+
+      WorldEntity * victim = aimingSystem->getNearestTarget();
+
+      if ( victim )
+      {
+        PRINTF(0)("FIRE: hit %s\n", victim->getClassName());
+        victim->hit( 20, this );
+      }
+      else
+      {
+        PRINTF(0)("FIRE: nothing hit\n");
+      }
+    }
+  }
+
 
   if( ( xMouse != 0 || yMouse != 0 ) && (this->getOwner() == SharedNetworkData::getInstance()->getHostID() || !State::isOnline() ) )
@@ -235,9 +318,9 @@
     attitude-= yMouse;
 
-    if ( attitude > 2.05 )
-      attitude = 2.05;
-
-    else if ( attitude < -1.15 )
-      attitude = -1.15;
+
+    if ( attitude > 1.95 )
+      attitude = 1.95;
+    else if ( attitude < -1.07 )
+      attitude = -1.07;
 
     xMouse = yMouse = 0;
@@ -304,4 +387,6 @@
     this->fallVelocity += 300.0f * time;
     velocity -= Vector(0.0, 1.0, 0.0) * this->fallVelocity;
+
+//     PRINTF(0)("vel %f\n", this->fallVelocity);
   }
   else
@@ -309,5 +394,4 @@
     this->fallVelocity = 0.0f;
   }
-
 
   this->shiftCoor( velocity*time );
@@ -346,4 +430,6 @@
   }
 
+  this->setOnGround(false);
+  this->aimingSystem->flushList();
 }
 
@@ -383,9 +469,30 @@
   }
   else if( event.type == KeyMapper::PEV_JUMP)
+  {
     this->bJump = event.bPressed;
-    this->bPosBut = event.bPressed;
-}
-
-
-
-
+  }
+  else if( event.type == KeyMapper::PEV_FIRE1)
+  {
+    this->bFire = event.bPressed;
+  }
+}
+
+
+void FPSPlayer::respawn( )
+{
+  if( State::isOnline())
+    toList( OM_PLAYERS );
+
+  this->damageTicker = 0.0f;
+
+  Playable::respawn();
+}
+
+
+void FPSPlayer::destroy( WorldEntity* killer )
+{
+  Playable::destroy( killer );
+
+  toList( OM_DEAD );
+}
+
Index: trunk/src/world_entities/creatures/fps_player.h
===================================================================
--- trunk/src/world_entities/creatures/fps_player.h	(revision 9110)
+++ trunk/src/world_entities/creatures/fps_player.h	(revision 9235)
@@ -9,4 +9,7 @@
 
 #include "playable.h"
+
+
+class AimingSystem;
 
 
@@ -27,4 +30,6 @@
     virtual void reset();
 
+    virtual void destroy(WorldEntity* killer);
+    virtual void respawn();
 
     virtual void tick(float time);
@@ -43,4 +48,5 @@
     bool                  bJump;              //!< jumping
     bool                  bPosBut;             //!< position button
+    bool                  bFire;              //!< fire button
 
     float                 xMouse;             //!< mouse moved in x-Direction
@@ -55,4 +61,10 @@
     float                 fallVelocity;        //!< velocity for falling down
     float                 jumpForce;           //!< the jump force
+
+    bool                  initWeapon;
+
+    AimingSystem*         aimingSystem;        //!< aiming system of the player
+
+    float                 damageTicker;        //!< ticker for dealing damage
 };
 
Index: trunk/src/world_entities/effects/explosion.cc
===================================================================
--- trunk/src/world_entities/effects/explosion.cc	(revision 9110)
+++ trunk/src/world_entities/effects/explosion.cc	(revision 9235)
@@ -40,5 +40,5 @@
   this->toList(OM_DEAD_TICK);
 
-  this->emitter = new BoxEmitter(Vector(10,10,10), 500, 45, M_2_PI);
+  this->emitter = new BoxEmitter(Vector(10,10,10), 200, 45, M_2_PI);
   this->emitter->addNodeFlags(PNODE_PROHIBIT_DELETE_WITH_PARENT);
   this->emitter->setParent(this);
@@ -83,5 +83,5 @@
     Explosion::explosionParticles->setLifeSpan(1.5, .3);
     Explosion::explosionParticles->setRadius(0.0, 10);
-    Explosion::explosionParticles->setRadius(.5, 15.0);
+    Explosion::explosionParticles->setRadius(.5, 30.0);
     Explosion::explosionParticles->setRadius(1.0, 10.0);
     Explosion::explosionParticles->setColor(0.0, 1,0,0,1);
@@ -113,5 +113,4 @@
 void Explosion::tick (float dt)
 {
-  printf("%f %f\n", this->lifeCycle, this->lifeTime);
   this->lifeCycle += dt;
   if(this->lifeTime < this->lifeCycle)
Index: trunk/src/world_entities/environments/mapped_water.cc
===================================================================
--- trunk/src/world_entities/environments/mapped_water.cc	(revision 9110)
+++ trunk/src/world_entities/environments/mapped_water.cc	(revision 9235)
@@ -337,5 +337,20 @@
 {
   // it's not too nice, but it works fine
-  PRINTF(0)("\nMappedWater XML Code:\n<MappedWater>\n  <waterpos>%f, %f, %f</waterpos>\n  <watersize>%f, %f</watersize>\n  <wateruv>%f</wateruv>\n  <waterflow>%f</waterflow>\n  <lightpos>%f, %f, %f</lightpos>\n  <waterangle>%f</waterangle>\n  <normalmapscale>%f</normalmapscale>\n  <shinesize>%f</waterpos>\n  <shinestrength>%f</shinestrength>\n  <reflstrength>%f</reflstrength>\n  <refraction>%f</refraction>\n  <watercolor>%f, %f, %f</watercolor>\n</MappedWater>\n", this->waterVerts[0], this->waterHeight, this->waterVerts[1], this->xWidth, this->zWidth, this->waterUV, this->waterFlow, this->lightPos.x, this->lightPos.y, this->lightPos.z, this->waterAngle, this->kNormalMapScale, this->shineSize, this->shineStrength, this->reflStrength, this->refraction, this->waterColor.x, this->waterColor.y, this->waterColor.z);
+  PRINT(0)("\nMappedWater XML Code:\n<MappedWater>\n");
+
+  PRINT(0)("  <waterpos>%f, %f, %f</waterpos>\n", this->waterVerts[0], this->waterHeight, this->waterVerts[1]);
+  PRINT(0)("  <watersize>%f, %f</watersize>\n", this->xWidth, this->zWidth);
+  PRINT(0)("  <wateruv>%f</wateruv>\n", this->waterUV);
+  PRINT(0)("  <waterflow>%f</waterflow>\n", this->waterFlow);
+  PRINT(0)("  <lightpos>%f, %f, %f</lightpos>\n", this->lightPos.x, this->lightPos.y, this->lightPos.z);
+  PRINT(0)("  <waterangle>%f</waterangle>\n", this->waterAngle);
+  PRINT(0)("  <normalmapscale>%f</normalmapscale>\n", this->kNormalMapScale);
+  PRINT(0)("  <shinesize>%f</shinesize>\n", this->shineSize);
+  PRINT(0)("  <shinestrength>%f</shinestrength>\n", this->shineStrength);
+  PRINT(0)("  <reflstrength>%f</reflstrength>\n", this->reflStrength);
+  PRINT(0)("  <refraction>%f</refraction>\n", this->refraction);
+  PRINT(0)("  <watercolor>%f, %f, %f</watercolor>\n", this->waterColor.x, this->waterColor.y, this->waterColor.z);
+
+  PRINT(0)("</MappedWater>\n");
 }
 
@@ -475,5 +490,5 @@
 
         OrxGui::GLGuiSlider* lightPosX = new OrxGui::GLGuiSlider();
-        lightPosX->setRange(-600, 600);
+        lightPosX->setRange(-4000, 4000);
         lightPosX->setValue(this->lightPos.x);
         lightPosX->setStep(15);
@@ -482,5 +497,5 @@
 
         OrxGui::GLGuiSlider* lightPosY = new OrxGui::GLGuiSlider();
-        lightPosY->setRange(-600, 600);
+        lightPosY->setRange(-4000, 4000);
         lightPosY->setStep(15);
         lightPosY->setValue(this->lightPos.y);
@@ -489,5 +504,5 @@
 
         OrxGui::GLGuiSlider* lightPosZ = new OrxGui::GLGuiSlider();
-        lightPosZ->setRange(-600, 600);
+        lightPosZ->setRange(-4000, 4000);
         lightPosZ->setStep(15);
         lightPosZ->setValue(this->lightPos.z);
@@ -504,7 +519,7 @@
 
         OrxGui::GLGuiSlider* waterHeight = new OrxGui::GLGuiSlider();
-        waterHeight->setRange(-500, 500);
+        waterHeight->setRange(100, 370);
         waterHeight->setValue(this->waterHeight);
-        waterHeight->setStep(10);
+        waterHeight->setStep(4);
         waterHeight->connect(SIGNAL(waterHeight, valueChanged), this, SLOT(MappedWater, setWaterHeight));
         waterHeightBox->pack(waterHeight);
@@ -547,4 +562,5 @@
   glDisable(GL_BLEND);
 
+  // TODO change texture coords, so water doesnt look distorted when xWidth != zWidth
   glBegin(GL_QUADS);
   // The back left vertice for the water
Index: trunk/src/world_entities/environments/model_entity.cc
===================================================================
--- trunk/src/world_entities/environments/model_entity.cc	(revision 9110)
+++ trunk/src/world_entities/environments/model_entity.cc	(revision 9235)
@@ -32,5 +32,5 @@
 {
   this->setClassID(CL_MODEL_ENTITY, "ModelEntity");
-  this->toList(OM_ENVIRON_NOTICK);
+  this->toList(OM_ENVIRON);
 
   this->speed = NULL;
@@ -71,7 +71,14 @@
 void ModelEntity::setMomentum (float angle, float x, float y, float z)
 {
+  Vector v(x,y,z);
+  v.debug();
+  v.normalize();
+  v.debug();
+
   if (this->momentum == NULL)
     this->momentum = new Quaternion;
-  *this->momentum = Quaternion(angle, Vector(x, y, z));
+  *this->momentum = Quaternion(angle, v);
+
+  this->momentum->debug();
 }
 
@@ -82,4 +89,7 @@
 
   if (this->momentum != NULL)
-    this->shiftDir(*this->momentum * dt);
+  {
+    this->shiftDir((*this->momentum * dt ).getNormalized());
+    //this->getAbsDir().debug();
+  }
 }
Index: trunk/src/world_entities/npcs/attractor_mine.cc
===================================================================
--- trunk/src/world_entities/npcs/attractor_mine.cc	(revision 9235)
+++ trunk/src/world_entities/npcs/attractor_mine.cc	(revision 9235)
@@ -0,0 +1,156 @@
+
+
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Patrick Boenzli
+   co-programmer:
+*/
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_WORLD_ENTITY
+
+
+#include "attractor_mine.h"
+
+
+#include "shader.h"
+#include "state.h"
+#include "debug.h"
+
+#include "player.h"
+#include "playable.h"
+
+#include "loading/factory.h"
+#include "loading/load_param.h"
+
+#include "effects/explosion.h"
+
+CREATE_FACTORY(AttractorMine, CL_ATTRACTOR_MINE);
+#include "script_class.h"
+CREATE_SCRIPTABLE_CLASS(AttractorMine, CL_ATTRACTOR_MINE,
+                        addMethod("setName", ExecutorLua1<BaseObject,const std::string&>(&BaseObject::setName))
+                       //Coordinates
+                        ->addMethod("setAbsCoor", ExecutorLua3<PNode,float,float,float>(&PNode::setAbsCoor))
+                        ->addMethod("getAbsCoorX", ExecutorLua0ret<PNode, float>(&PNode::getAbsCoorX))
+                        ->addMethod("getAbsCoorY", ExecutorLua0ret<PNode, float>(&PNode::getAbsCoorY))
+                        ->addMethod("getAbsCoorZ", ExecutorLua0ret<PNode, float>(&PNode::getAbsCoorZ))
+                       );
+
+
+
+
+AttractorMine::AttractorMine(const TiXmlElement* root)
+    : NPC(NULL)
+{
+  this->setClassID(CL_ATTRACTOR_MINE, "AttractorMine");
+
+  this->toList(OM_GROUP_02);
+
+  if ((float)rand()/RAND_MAX > .5f)
+    this->loadModel("models/ships/noxon_battle_drone.obj", .3);
+  else
+    this->loadModel("models/ships/noxon_battle_drone.obj", .2);
+
+  this->setDamage(30.0f);
+
+
+
+  this->shader = NULL;
+  if (likely(Shader::checkShaderAbility()))
+    this->shader = Shader::getShader("shaders/toon.vert", "shaders/toon.frag");
+
+  this->randomRotAxis = VECTOR_RAND(1);
+
+  if (root != NULL)
+    this->loadParams(root);
+}
+
+
+AttractorMine::~AttractorMine ()
+{
+  if (this->shader)
+    Shader::unload(this->shader);
+}
+
+
+void AttractorMine::loadParams(const TiXmlElement* root)
+{
+  NPC::loadParams(root);
+
+}
+
+
+void AttractorMine::destroy(WorldEntity* killer)
+{
+  Explosion::explode(this, Vector(10,10,10));
+  this->toList(OM_DEAD);
+
+}
+
+
+
+/**
+ *  the entity is drawn onto the screen with this function
+ *
+ * This is a central function of an entity: call it to let the entity painted to the screen.
+ * Just override this function with whatever you want to be drawn.
+ */
+void AttractorMine::draw() const
+{
+  glMatrixMode(GL_MODELVIEW);
+  glPushMatrix();
+  float matrix[4][4];
+
+  /* translate */
+  glTranslatef (this->getAbsCoor ().x,
+                this->getAbsCoor ().y,
+                this->getAbsCoor ().z);
+  /* rotate */
+  this->getAbsDir ().matrix (matrix);
+  glMultMatrixf((float*)matrix);
+
+  //   if (this->shader != NULL && this->shader != Shader::getActiveShader())
+  //     shader->activateShader();
+
+  this->getModel()->draw();
+  //   shader->deactivateShader();
+
+
+  /*  if (this->model)
+      this->model->draw();*/
+  glPopMatrix();
+}
+
+
+void AttractorMine::tick(float dt)
+{
+  PNode* attractNode = State::getPlayer()->getPlayable();
+  if (attractNode != NULL)
+  {
+    if (this->distance(attractNode) < 80)
+    {
+      Vector dist = (attractNode->getAbsCoor() -  this->getAbsCoor());
+      float distance = dist.len();
+      this->velocity += dist * (( 250.0 - distance) / distance * dt);
+    }
+  }
+
+  this->shiftCoor(this->velocity * dt);
+
+  //  Vector direction = (State::getCameraTarget()->getAbsCoor() - this->getAbsCoor());
+
+  //if (directin.len() < 100)
+  //  this->shiftCoor(direction *dt * 5 * exp(-direction.len() / 30.0));
+  this->shiftDir(Quaternion(.5 * dt, this->randomRotAxis));
+
+}
+
+
+
Index: trunk/src/world_entities/npcs/attractor_mine.h
===================================================================
--- trunk/src/world_entities/npcs/attractor_mine.h	(revision 9235)
+++ trunk/src/world_entities/npcs/attractor_mine.h	(revision 9235)
@@ -0,0 +1,32 @@
+
+#ifndef _ATTRACTOR_MINE_H
+#define _ATTRACTOR_MINE_H
+
+#include "npc.h"
+
+class AI;
+class Shader;
+
+class AttractorMine : public NPC {
+
+ public:
+  AttractorMine (const TiXmlElement* root = NULL);
+  virtual ~AttractorMine ();
+
+  virtual void loadParams(const TiXmlElement* root);
+
+  void addAI(AI* ai);
+
+  virtual void destroy(WorldEntity* killer);
+
+  virtual void tick(float dt);
+  virtual void draw() const;
+
+ private:
+   Vector   randomRotAxis;
+   Shader*  shader;
+
+   Vector   velocity;
+};
+
+#endif /* _ATTRACTOR_MINE_H */
Index: trunk/src/world_entities/npcs/gate.cc
===================================================================
--- trunk/src/world_entities/npcs/gate.cc	(revision 9235)
+++ trunk/src/world_entities/npcs/gate.cc	(revision 9235)
@@ -0,0 +1,220 @@
+
+
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific
+   main-programmer: Patrick Boenzli
+   co-programmer:
+*/
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_WORLD_ENTITY
+
+
+#include "util/loading/factory.h"
+#include "util/loading/load_param.h"
+
+#include "interactive_model.h"
+
+
+#include "gate.h"
+#include "class_list.h"
+
+#include "effects/explosion.h"
+
+
+
+using namespace std;
+
+
+CREATE_FACTORY(Gate, CL_GATE);
+
+
+#include "script_class.h"
+CREATE_SCRIPTABLE_CLASS(Gate, CL_GATE,
+                            addMethod("hide", ExecutorLua0<WorldEntity>(&WorldEntity::hide))
+                            ->addMethod("unhide", ExecutorLua0<WorldEntity>(&WorldEntity::unhide))
+                           // ->addMethod("destroy", ExecutorLua0<Gate>(&Gate::destroy()))    
+                            ->addMethod("setAbsCoor", ExecutorLua3<PNode,float,float,float>(&PNode::setAbsCoor))
+                            ->addMethod("getAbsCoorX", ExecutorLua0ret<PNode, float>(&PNode::getAbsCoorX))
+                            ->addMethod("getAbsCoorY", ExecutorLua0ret<PNode, float>(&PNode::getAbsCoorY))
+                            ->addMethod("getAbsCoorZ", ExecutorLua0ret<PNode, float>(&PNode::getAbsCoorZ))
+                       );
+
+
+//! list of all different animations a std md2model supports
+sAnim Gate::animationList[3] =
+{
+ // begin, end, fps, interruptable
+  {   0,  7,  30,  0 },    //!< OPEN
+  {   8, 15,  30,  0 },    //!< CLOSE
+  {  16, 18,  30,  0 }     //!< DIE
+};
+
+
+
+Gate::Gate(const TiXmlElement* root)
+{
+
+  this->setClassID(CL_GATE, "Gate");
+  this->scale = 1.0f;
+  this->actionRadius = 1.0;
+
+  if( root != NULL)
+    this->loadParams(root);
+
+  this->toList(OM_COMMON);
+  this->bLocked = false;
+  this->bOpen = false;
+
+  this->loadMD2Texture("maps/wheel.jpg");
+  this->loadModel("models/creatures/hypergate.md2", this->scale);
+
+  this->setAnimation(GATE_CLOSE, MD2_ANIM_ONCE);
+}
+
+
+Gate::~Gate ()
+{}
+
+
+
+/**
+ * loads the Settings of a MD2Creature from an XML-element.
+ * @param root the XML-element to load the MD2Creature's properties from
+ */
+void Gate::loadParams(const TiXmlElement* root)
+{
+  WorldEntity::loadParams(root);
+
+  LoadParam(root, "action-radius", this, Gate, setActionRadius)
+      .describe("sets the action radius of the door")
+      .defaultValues(3.0);
+  LoadParam(root, "scale", this, Gate, setScale)
+      .describe("sets the scale of the door")
+      .defaultValues(1.0);
+}
+
+
+/**
+ * sets the animatin of this entity
+ */
+void  Gate::setAnimation(int animNum, int playbackMode)
+{
+  if( likely(this->getModel(0) != NULL))
+    ((InteractiveModel*)this->getModel(0))->setAnimation(animationList[animNum].firstFrame,
+                                                         animationList[animNum].lastFrame,
+                                                         animationList[animNum].fps,
+                                                         animationList[animNum].bStoppable,
+                                                         playbackMode);
+}
+
+
+/**
+ * ticks the door
+ * @param time: time since last tick
+ */
+void Gate::tick (float time)
+{
+  if( likely(this->getModel(0) != NULL))
+    ((InteractiveModel*)this->getModel(0))->tick(time);
+
+
+  if( !this->bOpen)
+  {
+    if( this->checkOpen())
+    {
+      this->open();
+    }
+  }
+  else
+  {
+    if( !this->checkOpen())
+    {
+      this->close();
+    }
+  }
+
+
+}
+
+
+/**
+ * open the door
+ */
+void Gate::open()
+{
+  if( this->bLocked)
+    return;
+
+  this->setAnimation(GATE_OPEN, MD2_ANIM_ONCE);
+  this->bOpen = true;
+}
+
+
+/**
+ * close the door
+ */
+void Gate::close()
+{
+  this->setAnimation(GATE_CLOSE, MD2_ANIM_ONCE);
+  this->bOpen = false;
+}
+
+
+void Gate::destroy()
+{
+  this->setAnimation(GATE_DIE, MD2_ANIM_ONCE);
+
+  Explosion::explode(this, Vector(10,10,10));
+}
+
+
+/**
+ * checks if the door is open
+ */
+bool Gate::checkOpen()
+{
+
+  std::list<BaseObject*>::const_iterator it;
+  const std::list<BaseObject*>* list = ClassList::getList(CL_PLAYABLE);
+  WorldEntity* entity;
+  float distance;
+
+  if( list == NULL)
+    return false;
+
+  // for all players
+  for( it = list->begin(); it != list->end(); it++)
+  {
+    entity = dynamic_cast<WorldEntity*>(*it);
+
+    distance = fabs((this->getAbsCoor() - entity->getAbsCoor()).len());
+    if( distance < this->actionRadius)
+      return true;
+  }
+
+
+  list = ClassList::getList(CL_GENERIC_NPC);
+  if( list == NULL)
+    return false;
+  for( it = list->begin(); it != list->end(); it++)
+  {
+    entity = dynamic_cast<WorldEntity*>(*it);
+
+    distance = fabs((this->getAbsCoor() - entity->getAbsCoor()).len());
+    if( distance < this->actionRadius)
+      return true;
+  }
+
+  return false;
+}
+
+
+
Index: trunk/src/world_entities/npcs/gate.h
===================================================================
--- trunk/src/world_entities/npcs/gate.h	(revision 9235)
+++ trunk/src/world_entities/npcs/gate.h	(revision 9235)
@@ -0,0 +1,64 @@
+#ifndef _GATE_H
+#define _GATE_H
+
+#include "world_entity.h"
+
+#include "md2/md2Model.h"
+
+class TiXmlElement;
+
+
+//! animation names enumeration
+typedef enum GateAnimType
+{
+  GATE_OPEN = 0,
+  GATE_CLOSE,
+  GATE_DIE,
+
+  GATE_MAX_ANIMATIONS
+};
+
+
+class Gate : public WorldEntity
+{
+  public:
+    Gate(const TiXmlElement* root = NULL);
+    virtual ~Gate ();
+
+    virtual void loadParams(const TiXmlElement* root);
+
+    void setActionRadius(float radius) { this->actionRadius = radius; }
+    void setScale(float scale) { this->scale = scale; }
+
+    void open();
+    void close();
+    void destroy();
+
+    void lock() { this->bLocked = true; }
+    void unlock() { this->bLocked = false; }
+    bool isLocked() const { return this->bLocked; }
+
+
+    virtual void tick (float time);
+
+
+  private:
+    void init();
+    bool checkOpen();
+    void setAnimation(int animNum, int playbackMode = 0);
+
+
+  private:
+    bool           bOpen;             //!< true if the door is open
+    bool           bLocked;           //!< true if this door is locked
+    float          actionRadius;      //!< action radius
+    float          scale;             //!< the scale of the model
+
+    static sAnim   animationList[3];  //!< list of the animations
+
+    bool           bDead;
+
+
+};
+
+#endif /* _GATE_H */
Index: trunk/src/world_entities/npcs/generic_npc.cc
===================================================================
--- trunk/src/world_entities/npcs/generic_npc.cc	(revision 9110)
+++ trunk/src/world_entities/npcs/generic_npc.cc	(revision 9235)
@@ -82,4 +82,5 @@
 {
   this->setClassID(CL_GENERIC_NPC, "GenericNPC");
+
   this->toList(OM_GROUP_00);
 
@@ -206,4 +207,7 @@
 /**
  * each animation has to be initialized here
+ */
+/**
+ *
  */
 void GenericNPC::initNPC()
@@ -578,5 +582,5 @@
 
 
-void GenericNPC::destroy()
+void GenericNPC::destroy(WorldEntity* killer)
 {
   int randi = (int)(5.0f * (float)rand()/(float)RAND_MAX);
Index: trunk/src/world_entities/npcs/generic_npc.h
===================================================================
--- trunk/src/world_entities/npcs/generic_npc.h	(revision 9110)
+++ trunk/src/world_entities/npcs/generic_npc.h	(revision 9235)
@@ -77,5 +77,5 @@
 
 
-  void destroy();
+  virtual void destroy(WorldEntity* killer);
 
   private:
Index: trunk/src/world_entities/npcs/ground_turret.cc
===================================================================
--- trunk/src/world_entities/npcs/ground_turret.cc	(revision 9110)
+++ trunk/src/world_entities/npcs/ground_turret.cc	(revision 9235)
@@ -176,5 +176,5 @@
 }
 
-void GroundTurret::destroy()
+void GroundTurret::destroy(WorldEntity* killer)
 {
   this->setAbsDirSoft(Quaternion(-90, Vector(0,0,1)), 90);
Index: trunk/src/world_entities/npcs/ground_turret.h
===================================================================
--- trunk/src/world_entities/npcs/ground_turret.h	(revision 9110)
+++ trunk/src/world_entities/npcs/ground_turret.h	(revision 9235)
@@ -25,5 +25,5 @@
   virtual void leftWorld ();
 
-  virtual void destroy();
+  virtual void destroy(WorldEntity* killer);
 
   virtual void draw() const;
Index: trunk/src/world_entities/npcs/npc.cc
===================================================================
--- trunk/src/world_entities/npcs/npc.cc	(revision 9110)
+++ trunk/src/world_entities/npcs/npc.cc	(revision 9235)
@@ -19,7 +19,4 @@
 
 #include "npc.h"
-
-
-using namespace std;
 
 
@@ -51,5 +48,4 @@
 void NPC::loadParams(const TiXmlElement* root)
 {
-  if(root != NULL)
    WorldEntity::loadParams(root);
 }
